 /*
 * file      : callbacks.c
 * project   : BaseBuild
 * with      : Gtk-2
 *
 * copyright : (C) 2010 by Claude Bulin
 *
 * BaseBuild - Creation d'une base de programmation en langage C de type GNU avec les autotools
 * GNU General Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * OLD ADRESS:
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * NEW ADRESS:
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * 
 */


#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif

#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <glib/gstdio.h>

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <stdlib.h>

#include "../libbasebuild/libbasebuild.h"
#include "global.h"
#include "configuser.h"
#include "fileselect.h"
#include "callbacks.h"
#include "build.h"
#include "view.h"
#include "win_info.h"
#include "win_about.h"



VAR_CALLBACKS VarCallbacks;



// CHOIX VISU DU FICHIER DEPUIS LE CONTENU DU COMBOBOX
// 
void Callbacks_choice_to_see_file (void)
{
	gint	IndCombo = 0;
	gchar	*PtrCombo = NULL;
	
	if (VarCallbacks.Adr_combobox != NULL) {

		IndCombo = gtk_combo_box_get_active (GTK_COMBO_BOX (VarCallbacks.Adr_combobox));
		if (IndCombo > -1) {
			
			// GENERATION FICHIERS ET AFFICHAGE
			build_files ();
			
			// AFFICHAGE DU TEXTVIEW DEPUIS LE CONTENU DU COMBOBOX
			PtrCombo = gtk_combo_box_get_active_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox));
			
			if (0 == strcmp(PtrCombo, "Makefile.am")) {
				view_text (VarBuild.GstrMakefileAm->str);
			} else if (0 == strcmp(PtrCombo, "configure.in")) {
				view_text (VarBuild.GstrConfigureIn->str);
			} else if (0 == strcmp(PtrCombo, "src/Makefile.am")) {
				view_text (VarBuild.GstrSrcMakefileAm->str);
			} else if (0 == strcmp(PtrCombo, "man/Makefile.am")) {
				view_text (VarBuild.GstrManMakefileAm->str);
			} else if (0 == strcmp(PtrCombo, "lib/Makefile.am")) {
				view_text (VarBuild.GstrLibMakefileAm->str);
			} else if (0 == strcmp(PtrCombo, "pixmaps/Makefile.am")) {
				view_text (VarBuild.GstrPixmapsMakefileAm->str);
			} else if (0 == strcmp(PtrCombo, "menu/Makefile.am")) {
				view_text (VarBuild.GstrMenuMakefileAm->str);
			} else if (0 == strcmp(PtrCombo, "mime/Makefile.am")) {
				view_text (VarBuild.GstrMimeMakefileAm->str);
			} else if (0 == strcmp(PtrCombo, "glade/Makefile.am")) {
				view_text (VarBuild.GstrGladeMakefileAm->str);
			}
			else {
				if (2 == gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(VarCallbacks.Adr_spinbutton_label_src))) {
					gchar	*Str = g_strdup ("src2/Makefile.am");
					if (0 == strcmp(PtrCombo, Str)) {
						view_text (VarBuild.GstrSrc2MakefileAm->str);
					}
				}
			}
		}
	}
}
// GENERATION LISTE COMBOBOX
// 
void Callbacks_gen_list_combobox (void)
{
	GList	*ListCombo = NULL;
	GList	*List = NULL;
	gchar	*Ptr = NULL;
	gchar	*StrSaveCombo = g_strdup (gtk_combo_box_get_active_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox)));
	gint	 Ind = 0;
	gboolean BoolOk = FALSE;
	
	libcombo_alloc (GTK_COMBO_BOX (VarCallbacks.Adr_combobox));

	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "Makefile.am");
	// ALLOCATION
	ListCombo = g_list_append (ListCombo, g_strdup(("Makefile.am")));
	
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "configure.in");
	// ALLOCATION
	ListCombo = g_list_append (ListCombo, g_strdup(("configure.in")));
		
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "src/Makefile.am");
	// ALLOCATION
	ListCombo = g_list_append (ListCombo, g_strdup(("src/Makefile.am")));
	if (2 == gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(VarCallbacks.Adr_spinbutton_label_src))) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "src2/Makefile.am");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("src2/Makefile.am")));
	}
	if (TRUE == gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_manpage")))) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "man/Makefile.am");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("man/Makefile.am")));
	}
	if (TRUE == gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_lib_statique")))) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "lib/Makefile.am");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("lib/Makefile.am")));
	}
	if (TRUE == gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_pixmaps")))) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "pixmaps/Makefile.am");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("pixmaps/Makefile.am")));
	}
	if (TRUE == gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_menu")))) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "menu/Makefile.am");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("menu/Makefile.am")));
	}
	if (TRUE == gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_mime")))) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "mime/Makefile.am");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("mime/Makefile.am")));
	}
	if (TRUE == gtk_toggle_button_get_active ( GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_lib_gtk")))) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "glade/Makefile.am");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("glade/Makefile.am")));
	}
	if (TRUE == VarCallbacks.BoolCreateBuild) {
		gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), "Action");
		// ALLOCATION
		ListCombo = g_list_append (ListCombo, g_strdup(("Action")));
	}
	
	// CHERCHE L INDICE
	List = g_list_first (ListCombo);
	while (List && StrSaveCombo) {
		if (NULL != (Ptr = (gchar *)List->data)) {
			if (0 == strcmp(StrSaveCombo, Ptr)) {
				BoolOk = TRUE;
				break;
			}
			Ind ++;
		}
		List = g_list_next (List);
	}

	// REMOVE GLIST
	List = g_list_first (ListCombo);
	while (List) {
		if ((Ptr = (gchar *)List->data)) {
			g_free (Ptr);
			Ptr = NULL;
			List->data = NULL;
		}
		List = g_list_next (List);
	}
	g_list_free (ListCombo);
	ListCombo = List = NULL;
	
	if (NULL != StrSaveCombo) {
		g_free (StrSaveCombo);
		StrSaveCombo = NULL;
	}
	
	gtk_combo_box_set_active (GTK_COMBO_BOX (VarCallbacks.Adr_combobox), BoolOk == TRUE ? Ind : 0);
}
// -RECUPERATION DES DATAS
// -SAUVEGARDE DES DATAS
// 
void remove_memory_apply (void)
{
	g_print ("\n--------------------------------------------------\n");
	PRINT_FUNC_LF();
	g_print ("--------------------------------------------------\n");
	
	g_print ("Recuperation position et taille de la fenetre\n");
	gdk_window_get_root_origin (WindMain->window, &Config.WinPos_X, &Config.WinPos_Y);
	gdk_window_get_size (WindMain->window, &Config.WinWidth, &Config.WinHeight);
	
	g_print ("Sauvegarde de la configuration\n");
	config_save ();
	
	g_print ("config_remove ()\n");
	config_remove ();
	g_print ("remove_combo ()\n");
	libcombo_remove ();
	g_print ("build_remove ()\n");
	build_remove ();
	
	g_print ("\n");
}
// QUIT WITH delete_event
//
gboolean on_window_main_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	remove_memory_apply ();
	gtk_main_quit ();
	return FALSE;
}
// QUIT WITH destroy_event
//
gboolean on_window_main_destroy_event (GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	remove_memory_apply ();
	gtk_main_quit ();
	return FALSE;
}
// QUIT WITH menu
//
void on_imagemenuitem_quit_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	remove_memory_apply ();
	gtk_main_quit ();
}
// MENU ABOUT
//
void on_imagemenuitem_about_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	WinAbout_open ();
}
// INIT PATH PROJET
//
void on_button_path_projet_realize (GtkWidget *widget)
{
	VarCallbacks.Adr_button_path = GTK_BUTTON (widget);
	gtk_button_set_use_underline (GTK_BUTTON (widget), FALSE);
	gtk_button_set_label (GTK_BUTTON (widget), Config.Path);
}
// TEST L ACCESSIBLITE AU DOSSIER
//
gboolean Callbacks_test_write (gchar *path)
{
	gboolean  BoolWriteOk = FALSE;
	FILE     *fp = NULL;
	gchar    *str = NULL;
	
	if (path[ 0 ] == '/' && path[ 1 ] != '\0') {
		str = g_strdup_printf ("%s/basebuild_tst_write_dummy.txt", path);
		if (NULL != (fp = fopen (str, "w"))) {
			BoolWriteOk = TRUE;
			fclose (fp);
			g_unlink (str);
		}
		g_free (str);
		str = NULL;
	}
	
	// TODO: FENETRE D ALERTE POUR L UTILISATEUR
	if (BoolWriteOk == FALSE) {
		wininfo_create (
			_("Erreur choix lieu de stockage !"),
			_("   Le lieu de stockage temporaire doit pouvoir     "),
			  "\n",
			_("   etre accessible en ecriture."),
			  "\n\n",
			_("   Veuillez recommencer."),
			  "\n",
			  "");
	}
	
	return (BoolWriteOk);
}
// CHANGEMENT DE PATH DU PROJET
//
void file_select_new_path_destination (gchar *path)
{
	if (TRUE == Callbacks_test_write (path)) {
		g_free (Config.Path);
		Config.Path = NULL;
		Config.Path = g_strdup (path);
		gtk_button_set_use_underline (GTK_BUTTON (VarCallbacks.Adr_button_path), FALSE);
		gtk_button_set_label (GTK_BUTTON (VarCallbacks.Adr_button_path), Config.Path);
	}
}
// CHANGEMENT DE PATH PROJET
// 
void on_button_path_projet_clicked (GtkButton *button, gpointer user_data)
{
	fileselect ("Choix du dossier pour le projet", TRUE, file_select_new_path_destination, Config.Path);
}
// INIT NOM PROJET
//
void on_entry_name_projet_realize (GtkWidget *widget, gpointer user_data)
{
	if ('\0' == *Config.NameProject) {
		g_free (Config.NameProject);
		Config.NameProject = NULL;
		Config.NameProject = g_strdup ("NameProject");
	}
	gtk_entry_set_text (GTK_ENTRY (widget), Config.NameProject);
	VarCallbacks.Adr_name_project = widget;
}
// MODIFICATION NOM DU PROJET
//
void on_entry_name_projet_changed (GtkEditable *editable, gpointer user_data)
{
	if (NULL != VarCallbacks.Adr_name_project) {
		g_free (Config.NameProject);
		Config.NameProject = NULL;
		Config.NameProject = g_strdup( gtk_entry_get_text (GTK_ENTRY (VarCallbacks.Adr_name_project)));
		
		// GENERATION FICHIERS ET AFFICHAGE
		Callbacks_choice_to_see_file ();
		
		// DE ... ACTIVATION DU BOUTON APPLIQUER
		gtk_widget_set_sensitive (GTK_WIDGET(GLADE_GET_OBJECT("button_appliquer")),
			('\0' == *gtk_entry_get_text (GTK_ENTRY (VarCallbacks.Adr_name_project))) ? FALSE : TRUE);
	}
	// button_appliquer
}
// INIT SPINBUTTON VERSION A B C
//
void on_spinbutton_version_A_realize (GtkWidget *widget, gpointer user_data)
{
	VarCallbacks.Adr_spinbutton_version_A = widget;
}
void on_spinbutton_version_B_realize (GtkWidget *widget, gpointer user_data)
{
	VarCallbacks.Adr_spinbutton_version_B = widget;
}
void on_spinbutton_version_C_realize (GtkWidget *widget, gpointer user_data)
{
	VarCallbacks.Adr_spinbutton_version_C = widget;
}
// CHANGEMENT NUMERO DE VERSION
//
void on_spinbutton_version_changed (GtkSpinButton *spinbutton, gpointer user_data)
{
	if (NULL != VarCallbacks.Adr_spinbutton_version_A &&
	    NULL != VarCallbacks.Adr_spinbutton_version_B &&
	    NULL != VarCallbacks.Adr_spinbutton_version_C) {
		// GENERATION FICHIERS ET AFFICHAGE
		Callbacks_choice_to_see_file ();
	}
}
// INIT SPINBUTTON NOMBRE DE DOSSIERS
//
void on_spinbutton_nbr_rep_src_realize (GtkWidget *widget, gpointer user_data)
{
	VarCallbacks.Adr_spinbutton_label_src = widget;
}
// CHANGEMENT NOMBRE DE DOSSIERS
//
void on_spinbutton_nbr_rep_src_changed (GtkSpinButton *spinbutton, gpointer user_data)
{
	if (NULL != VarCallbacks.Adr_spinbutton_label_src) {
	switch (gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(VarCallbacks.Adr_spinbutton_label_src))) {
	case 1 :
		gtk_label_set_label (GTK_LABEL (VarCallbacks.Adr_label_src), "<b>src</b>");
		break;
	case 2 :
		gtk_label_set_label (GTK_LABEL (VarCallbacks.Adr_label_src), "<b>src src2</b>");
		break;
	}
	Callbacks_gen_list_combobox ();
	}
}
// INIT NOMS DOSSIERS SOURCE
//
void on_label_dossier_src_realize (GtkWidget *widget, gpointer user_data)
{
	gtk_label_set_label (GTK_LABEL (widget), "<b>src</b>");
	VarCallbacks.Adr_label_src = widget;
}
// INIT COMBOBOX
//
void on_combobox_voir_fichiers_realize (GtkWidget *widget, gpointer user_data)
{
	VarCallbacks.Adr_combobox = GTK_COMBO_BOX (widget);
	libcombo_alloc (GTK_COMBO_BOX (widget));
	// GENERATION FICHIERS ET AFFICHAGE
	Callbacks_gen_list_combobox ();
}
// SELECTION COMBOBOX
//
void on_combobox_voir_fichiers_changed (GtkComboBox *combobox, gpointer user_data)
{
	// GENERATION FICHIERS ET AFFICHAGE
	Callbacks_choice_to_see_file ();
}
// INIT TEWTVIEW
//
void on_textview_voir_fichiers_realize (GtkWidget *widget, gpointer user_data)
{
	VarCallbacks.Adr_textview = widget;
}
// CONFIRME CREATE BUILDER
// 
void on_button_appliquer_clicked (GtkButton *button, gpointer user_data)
{
	VarCallbacks.BoolCreateBuild = TRUE;
	build_clicked ();
}
// CHOICE WITH CLICK ON REP
// 
void on_checkbutton_dossier_clicked (GtkButton *button, gpointer user_data)
{
	if (button == GTK_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_menu"))) {
		if (TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_menu")))) {
			gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_pixmaps")), TRUE);
			// gtk_widget_set_sensitive (GTK_WIDGET(GLADE_GET_OBJECT("combobox_categories_menu")), TRUE);
		}
	}
	else if (button == GTK_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_pixmaps"))) {
		if (FALSE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_pixmaps"))) &&
			TRUE == gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_menu")))) {
			gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_menu")), FALSE);
			// gtk_widget_set_sensitive (GTK_WIDGET(GLADE_GET_OBJECT("combobox_categories_menu")), FALSE);
		}
	}
	
	gtk_widget_set_sensitive (GTK_WIDGET(GLADE_GET_OBJECT("combobox_categories_menu")), gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_dossier_menu"))));
	
	// GENERATION FICHIERS ET AFFICHAGE
	Callbacks_gen_list_combobox ();
}
// CHOICE WITH CLICK ON LIB
//
void on_checkbutton_lib_clicked (GtkButton *button, gpointer user_data)
{

	gtk_widget_set_sensitive (GTK_WIDGET(GLADE_GET_OBJECT("frame_paquet_glade")),
			gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (GLADE_GET_OBJECT("checkbutton_lib_gtk"))));
	// GENERATION FICHIERS ET AFFICHAGE
	Callbacks_gen_list_combobox ();
}
// INIT COMBOBOX CATEGORIES
//
void on_combobox_categories_menu_realize (GtkWidget *widget, gpointer user_data)
{
	VarCallbacks.Adr_combobox_categories = GTK_COMBO_BOX (widget);

	libcombo_alloc (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories));
	
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "AudioVideo");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Audio");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Video");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Development");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Education");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Game");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Graphics");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Network");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Office");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Settings");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "System");
	gtk_combo_box_append_text (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), "Utility");
	
	gtk_combo_box_set_active (GTK_COMBO_BOX (VarCallbacks.Adr_combobox_categories), 3);
}
// RETOURNE LA CATEGORIE ACTIVE
//
gchar *Callbacks_get_entry_categories_item (void)
{
	*VarCallbacks.StrCategoriesEntry = '\0';
	g_sprintf (&VarCallbacks.StrCategoriesEntry[0], "Categories=Application;%s\n", gtk_combo_box_get_active_text (GTK_COMBO_BOX(VarCallbacks.Adr_combobox_categories)));
	return (VarCallbacks.StrCategoriesEntry);
}








